const P_CHOOSEGAME = 'choose-game';
const P_CHOOSEAGE = 'choose-age';
const P_FLASHCARD = 'flash-card';
const P_MANDALA = 	'mandala';
const P_LINGKING = 'linking';
const P_BOOKS = 'books';
const P_BIT = 'bit';
const P_MATH = 'math';
const P_SETTING = 'setting';
const STT_ERROR = 'ERROR';
const STT_OK = 'OK';
const IOS = 'iOS'
const ANDROID = 'Android'
const DEVICE_ID = 'stvKIDgenius';
const STATE_TRIAL = 1;
const STATE_ACTIVE = 2;
const ID_ACTIVE_DLG = 'activeDlg'
const ACTION_ACTIVE = 'active'
const ACTION_TESTING = 'testing'
const ACTION_LEARNING = 'learning'
const ACTION_PAUSE = 'pause'
const ACTION_PLAY = 'play'
const BOOKS_ID = 181;
const ERR_SYSTEM = 'Error System. Please retart App.';
const ERR_CONNECTION = 'Error Connection.';
const HOST = 'http://kidgenius2.setechviet.vn/';
const API_LOAD_CARD_SET = HOST + 'apiflashcard/loadcardset/';
const API_LOAD_LIST_CARD = HOST + 'apiflashcard/loadlistcard/';
const API_DOWNLOAD = HOST + 'apiflashcard/download/';
const API_UPDATE_INFO = HOST + 'apiflashcard/updateinfo/';
const API_UPDATE_LINKING_INFO = HOST + 'apilinkingmemory/updateinfo/';

// const APIT_FLASHCARD_CARDSET = HOST+'apimandala/loadcardset/';
const API_MANDALA_LIST_CARD = HOST+'apimandala/loadlistcard/';
const API_LINKING_LIST_CARD = HOST+'apilinkingmemory/loadstoryset/';
const API_LINKING_LIST_STORY = HOST+'apilinkingmemory/loadliststory/';
const API_LINKING_STORY_CARD = HOST+ 'apilinkingmemory/loadresource/';
const API_LINKING_DOWNLOAD = HOST + 'apilinkingmemory/download/';
const API_ACTIVE = HOST + 'apiuser/active/';
const API_LOAD_LIST_BOOKS = HOST + 'apibook/loadlistbook/';




const API_UPDATE_PROFILE = HOST + 'apiuser/updateprofile/'
const API_CHECK_UID_FB = HOST + 'apiuser/findemailbyuid/';
const API_LOGIN_VIA_FB = HOST + 'apiuser/loginviafb/';
const API_LOGOUT = HOST + 'apiuser/logout/';
const API_CHECK_TOKEN = HOST + 'apiuser/checktoken/';

const TIME_EFFECT = 500;
const TIME_CLAP = 3000;
const TIME_SPLASH_SCREEN  = 3000;
const TIME_FLASHCARD  = 1000;
const TIME_LINKING = 4000;
const EXT_IMG = '.jpg';
const EXT_AUDIO = '.mp3';
const MAX_COUNT_CARD_SHOW = 500;
const PATH_CARDSET = 'cardsets'
const PATH_LINKING = 'linkings'
const PATH_MANDALA = 'mandala';
const ID_MATH_NUMBER = 1000;
const OPERATION_GAME = "operation";
var _db;
var _dbShortName = 'kigappdb';
var _dbVersion = '1.0';
var _dbDisplayName = 'kigappdb';
var _dbMaxSize = 65535;

//Var connection http post/ connect local db
var KGConnection = function() {
  this.DbLite = null;
  this.Token = '';
  this.info = null;

  this.test = function(value) {
    return value;
  };

function errorHandler(transaction, error) {
	   // console.log('Error: ' + error.message + ' code: ' + error.code);
	   console.log('errorHandler:');
	   console.log(error)
	}
function nullHandler(){};


  this.init = function() {
      this.DbLite = openDatabase(_dbShortName, _dbVersion, _dbDisplayName, _dbMaxSize);
    }
    //Request to httP
  this.sendHttpResquest = function(api, _info, successCallback, errorCallback) {
    console.log('Requesting....');
    //form is validated
    //var content = _info
    $.ajax({
      type: 'POST',
      data: _info,

      url: api,
      //headers: {"Access-Control-Allow-Origin": "*"},
      //crossDomain : true,
      success: function(data) {
        successCallback(data)
      },
      error: function() {
        //console.log(data);
        errorCallback(ERR_CONNECTION);
      }
    });
  }

  this.clearConfig = function() {
    if(!this.DbLite){
      this.init();
    }
    this.DbLite.transaction(function(tx) {
      tx.executeSql('DELETE FROM Config', [], nullHandler, errorHandler);
    });
  }

  this.setConfig = function(key, value, isUpdate, successCallback, errorCallback) {
    if(!this.DbLite){
      this.init();
    }
    this.DbLite.transaction(function(tx) {
      //alert(value)
      //alert(_config.info.Age)
      console.log('Del Config')
      tx.executeSql("DELETE FROM Config WHERE key = '"+key + "'", [], function(){
        console.log('insert Config')
        console.log(key)
        console.log(value)
        tx.executeSql('INSERT INTO Config(Key,Value) VALUES (?,?)', [key, value], nullHandler, errorCallback);
      }, errorHandler);

      // if (isUpdate) {
      //   tx.executeSql("UPDATE Config SET Value='" + value + "' WHERE Key='" + key + "'",[], nullHandler, errorCallback);
      // } else {
      //tx.executeSql('INSERT INTO Config(Key,Value) VALUES (?,?)', [key, value], nullHandler, errorCallback);
      //}
    }, nullHandler, successCallback);
  }

  this.getHistoryCard = function(cardsetId, successCallback, errorCallback) {
    cardHistory = {}
    this.DbLite.transaction(function(tx) {
      console.log(cardsetId)
      tx.executeSql('CREATE TABLE IF NOT EXISTS user_card_history(card_id int PRIMARY KEY, count int, cardset_id int, date_modify datetime)', [], nullHandler, errorHandler);
      tx.executeSql("SELECT * FROM user_card_history WHERE cardset_id = " + cardsetId+' order by date_modify DESC', [],
        function(transaction, result) {
          //alert(_result);
          if (result != null && result.rows != null && result.rows.length != 0) {
            info = {};
            cardHistory.date_modify = result.rows.item(0).date_modify
            for (var i = 0; i < result.rows.length; i++) {
              row = result.rows.item(i);
              cardHistory[row.card_id] = row.count;
            }
            successCallback(cardHistory)
              //alert(_result);
              //if(_self.info.)
              //alert(_self.info)
              // /_self.displayName = row.Value;
          } else {
            successCallback(cardHistory)
          }
        }, nullHandler);
    }, errorCallback, nullHandler);
  }

  this.saveHistoryCard = function(cardsetId, arrId, arrCount, date, errorCallback) {

    this.DbLite.transaction(function(tx) {
      console.log(arrId)
      console.log(arrCount)
      tx.executeSql('CREATE TABLE IF NOT EXISTS user_card_history(card_id int PRIMARY KEY, count int, cardset_id int, date_modify datetime)', [], nullHandler, errorHandler);
      query = 'DELETE FROM user_card_history WHERE card_id IN (' + arrId.toString() + ')'
      tx.executeSql(query, [],
        function() {
          for (i = 0; i < arrId.length; i++) {
            tx.executeSql('INSERT INTO user_card_history VALUES (?,?,?,?)', [arrId[i], arrCount[i], cardsetId, date], nullHandler, errorCallback);
          }
        }, errorHandler);
    }, errorCallback, nullHandler);
  }

  this.saveHistoryStory = function(story_id, count, cardsetId, date, errorCallback) {
    if (!this.DbLite) {
      this.init()
    }
    this.DbLite.transaction(function(tx) {
      tx.executeSql('CREATE TABLE IF NOT EXISTS user_story_history(story_id int PRIMARY KEY, count int,cardset_id int, date_modify datetime)', [], nullHandler, errorHandler);
      query = 'DELETE FROM user_story_history WHERE story_id = ' + story_id
        //console.log(query)
      tx.executeSql(query, [],
        function() {
          // console.log(story_id)
          // console.log(count)
          // console.log(cardsetId)
          // console.log(date)
          tx.executeSql('INSERT INTO user_story_history VALUES (?,?,?,?)', [story_id, count, cardsetId, date], nullHandler, errorCallback);
        }, errorHandler);
    }, errorCallback, nullHandler);
  }

  this.saveMandalaCardset = function(cardsetId, modified_date) {
    if (!this.DbLite) {
      this.init();
    }
    this.DbLite.transaction(function(tx) {
      console.log("Create Table");
      var sqlCreate = 'CREATE TABLE IF NOT EXISTS mandala_cardset(id int PRIMARY KEY, modified_date datetime)';
      tx.executeSql(sqlCreate, [], nullHandler, errorHandler);

      console.log("DELETE EXISTS CARDSET");
      var sqlDelete = 'DELETE FROM mandala_cardset WHERE id = ' + cardsetId;
      tx.executeSql(sqlDelete, [], function() {
        console.log("INSERT CARDSET");
        tx.executeSql('INSERT INTO mandala_cardset VALUES (?,?)', [cardsetId, modified_date], nullHandler, errorHandler);
      }, errorHandler);
    }, function(){console.log("Save Failed!!")} , function(){console.log("Save Successfully!!")});
  }

  this.getMandalaCardset = function(cardsetId, s) {
    if (!this.DbLite) {
      this.init();
    }

    this.DbLite.transaction(function(tx) {
      console.log("Create Table");
      var sqlCreate = 'CREATE TABLE IF NOT EXISTS mandala_cardset(id int PRIMARY KEY, modified_date datetime)';
      tx.executeSql(sqlCreate, [], nullHandler, errorHandler);

      console.log("Find cardset");
      var sqlSearch = 'SELECT modified_date FROM mandala_cardset WHERE id = ' + cardsetId;
      tx.executeSql(sqlSearch, [], function(transaction, rs) {
        try {
          var modified_date = rs.rows.item(0).modified_date;
          console.log("SELECT OK");
          s(modified_date);
        } catch (e) {
          console.log("Can't find Cardset")
          s(null);
        }
      })
    });
  }
  this.getHistoryStory = function(cardsetId, successCallback, errorCallback) {
    cardHistory = {}
    if (!this.DbLite) {
      this.init()
    }
    this.DbLite.transaction(function(tx) {
      console.log(cardsetId)
      tx.executeSql('CREATE TABLE IF NOT EXISTS user_story_history(story_id int PRIMARY KEY, count int,cardset_id int, date_modify datetime)', [], nullHandler, errorHandler);
      tx.executeSql("SELECT * FROM user_story_history WHERE cardset_id = " + cardsetId, [],
        function(transaction, result) {
          //alert(_result);
          if (result != null && result.rows != null && result.rows.length != 0) {
            info = {};
            for (var i = 0; i < result.rows.length; i++) {
              row = result.rows.item(i);
              cardHistory[row.story_id] = row.date_modify;
            }
            successCallback(cardHistory)
              //alert(_result);
              //if(_self.info.)
              //alert(_self.info)
              // /_self.displayName = row.Value;
          } else {
            successCallback(cardHistory)
          }
        }, nullHandler);
    }, errorCallback, nullHandler);
  }

  // this.loginSuccess = function(info){
  //   console.log('loginSuccess')
  //   this.info = info;
  // };

  this.loginFail = function(){
    console.log('loginFail')
  }

  this.checkLogin = function(successCallback) {
    if (!this.DbLite) {
      this.init()
    }

    var _self = this;
    //console.log(this)

    this.DbLite.transaction(function(transaction) {
     
      transaction.executeSql("SELECT * FROM Config", [],
        function(transaction, result) {
          //alert(_result);
          if (result != null && result.rows != null && result.rows.length != 0) {
            info = {};
            for (var i = 0; i < result.rows.length; i++) {
              row = result.rows.item(i);
              info[row.Key] = row.Value;
            }
            _self.info = info;
            successCallback(info);


          }
          else{
          	_self.loginFail();
          }
        }, errorHandler, nullHandler);
    }, errorHandler, nullHandler);
  }

  //Get list Id card is played for testing


  this.getListPlayed = function(successCallback, errorCallback) {
    var arrId = []
    if (!this.DbLite) {
      this.init()
    }

    this.DbLite.transaction(function(transaction) {
      var _self = this;
      transaction.executeSql("SELECT * FROM user_card_history  WHERE count >=" + MAX_COUNT_CARD_SHOW + " group by cardset_id", [],
        function(transaction, result) {
          //alert(_result);
          if (result != null && result.rows != null && result.rows.length != 0) {
            info = {};
            for (var i = 0; i < result.rows.length; i++) {
              row = result.rows.item(i);
              arrId.push(row.cardset_id) //=row.date_modify;
            }
          }
          successCallback(arrId);
          //console.log(arrId)
        }, errorHandler, nullHandler);
    }, errorHandler, nullHandler);
  }
}



// }

var KIDPAGE  = function(){
	KGConnection.apply(this,arguments);

	this.test1 =  function(value){
		console.log('Test1')
	};

	this.test2 = function(value){
		console.log('123')
		return this.test(value);
	}

	this.handleHashChange = function(){
		console.log('hashchange')
		if(this.template){
			console.log('Template Ready')
			var hash = location.hash.substring(1).split("&");
			//console.log(hash[0])
			switch(hash[0]){
				case P_CHOOSEAGE:
				break;
				case P_CHOOSEGAME:
				break;
				case P_FLASHCARD:
					this.setTitleToolbar('Flash card');
					this.curPage = P_FLASHCARD;
					this.renderFlashcard(hash);
				break;
				case P_MANDALA:
				break;
				case P_LINGKING:
				break;
				case P_BOOKS:
				break;
				case P_BIT:
				break;
				case P_BOOKS:
				break;
				case P_SETTING:
				break;
				default:
				break;
			}
		}

		// setTimeout(function() {	var hash = location.hash.substring(1).split("&");
		// console.log(hash);}, 1000);
	

	};	

	this.setTitleToolbar = function(title){
		this.titleToolbar.innerHTML = title;
	}
	this.loadPage = function() {
		console.log('loadPage');
		var _self = this;

		this.dlgLoading = document.getElementById('modal');
		this.dlgLearnmore = document.getElementById('dlgLearnmore');
		this.dlgEndgame = document.getElementById('dlgEndgame');
		this.dlgPlayHistory = document.getElementById('dlgPlayHistory');
		this.fabBtn = document.getElementById('kidFab');
		this.backButton = document.getElementById('paperBack');
		this.navButton =  document.getElementById('paperToggle');
		this.titleToolbar =  document.getElementById('title');
		this.content =  document.getElementById('container');

		this.audioLoaded = 0; 
		this.imgLoaded = 0;

		this.cardsetData = [];
		this.timeoutPlay = null;
		this.speakTime = 800;
		this.listcardPlay = {};

		this._isBackButtonClick = -1;
		this.template = null;
		this.arrIdTesting = [];
		this.rateSpeak = 0.5;
		this.speedSpeak = 1;
		this.curPage = '';
		//this.device = typeof(device) == "undefined" ? "" : device.platform;

		var lang = typeof(this.info.pref_lang) === 'undefined' ? 'en': this.info.pref_lang;
        var _xmlString = new XmlString(lang);
        _xmlString.getTemplate(function(template){
              _self.template = template;
              _self.initTemplate();
          })    

		if(location.hash == '' || location.hash == '#'){
			if (!this.info.Age) {
		      location.hash = P_CHOOSEAGE
		    } 
		    else {
		      location.hash = P_CHOOSEGAME
		    }
		 }
		 else{
		 	console.log('f5')
		 	this.handleHashChange();
		 }

	}

	this.initTemplate = function(){
		this.handleHashChange();
	}

	this.getListcardFromServer = function(game_id,successCallback){
		var _self = this;
		var data =  {
	          'User[token]' :   _self.info.Token,
	          'Ages[age_id]' :  _self.info.Age,
	          'Cardset[game_id]': game_id	        };

	    api = API_LOAD_CARD_SET           
	    _self.sendHttpResquest(api,data,function(data){
	          var response = JSON.parse(data);
	          if(response.status == STT_OK)
	          { 
	          		console.log(response)
	          		_self.cardsetData = response.cardsets;
	            	successCallback();
	          }
	          else
	          {
	            console.log(response);
	            alert(response.reason);
	            _self.clearConfig();
	            window.location.replace('./index.html')
	          }
	    },null);
	}

	//render first flash card
	this.renderFlashcard = function(hash){
		var _self = this;
		if(hash.length == 1){//no card list
			_self.getListcardFromServer(1,function(){
				_self.renderFlashcardView(0);
			});
		}
		else{

			_self.renderFlashcardView();
		}
	}

	this.renderFlashcardView = function(cardset_id){
		var _self = this;
		//_self.content.innerHTML = _self.createDataView(_self.getListCardView(cardset_id))
		_self.createDataView(_self.getListCardView(cardset_id))
	}

	this.getListCardView = function(parent_id){
		var viewList = []
		for(var i=0; i<this.cardsetData.length; i++){
			if(this.cardsetData[i].cardset_parent == parent_id){
				viewList.push(this.cardsetData[i])
			}
		}
		return viewList;
		//_self.createDataView(response.cardsets)
	}

	//cardset clicked
	this.cardsetClicked = function(cardset_id){
		location.hash = this.curPage + '&'+ cardset_id;
	}


	this.createDataView = function(_viewList){
		var _self = this;
        var objContent  = document.createElement('div')
        numOfView = _viewList.length
        var randomMC = new  RandomColor(numOfView)
        for(i=0; i< numOfView ;i=i+2)
        {

          var rowDiv = document.createElement('div')
          rowDiv.setAttribute('class','row')

          paperCard = document.createElement('paper-card')
          divItem = document.createElement('div')
          divItem.setAttribute('class','card-item');
          paperButton = document.createElement('paper-button')
          paperButton.value = _viewList[i].cardset_id;
          if(_viewList[i].disable)
            paperButton.disabled = true;
          else{
            //paperButton.setAttribute('onclick',function(){_self.cardsetClicked(_viewList[i].cardset_id)})
            paperButton.addEventListener("click",function(){
            	console.log(this);
            	_self.cardsetClicked(this.value)
            });         	
            paperButton.setAttribute('style','background-color:'+randomMC[i]);
          }
          paperButton.innerHTML =  _viewList[i].cardset_name;
          divItem.appendChild(paperButton);

          paperCard.appendChild(divItem);

          divItem = document.createElement('div')
          divItem.setAttribute('class','actions');
          paperButton = document.createElement('paper-button')
          paperButton.setAttribute('onclick','showDLG('+_viewList[i].cardset_id+')')
          paperButton.innerHTML = _self.template.learn_more;
          divItem.appendChild(paperButton);
          paperCard.appendChild(divItem);

          rowDiv.appendChild(paperCard)

          if((_viewList[i+1]))
          {

            paperCard = document.createElement('paper-card')
            divItem = document.createElement('div')
            divItem.setAttribute('class','card-item');
            paperButton = document.createElement('paper-button')
            //paper-button.setAttribute('id','crds'+_viewList[i].cardset_id)
            if(_viewList[i+1].disable)
              paperButton.disabled = true;
            else{
               paperButton.setAttribute('onclick','cardsetClicked('+_viewList[i+1].cardset_id+')')
              //paperButton.addEventListener("click",_self.cardsetClicked(_viewList[i +1].cardset_id)); 
              paperButton.setAttribute('style','background-color:'+randomMC[i+1]);
            }
            paperButton.innerHTML =  _viewList[i+1].cardset_name;
            divItem.appendChild(paperButton);

            paperCard.appendChild(divItem);

            divItem = document.createElement('div')
            divItem.setAttribute('class','actions');
            paperButton = document.createElement('paper-button')
            paperButton.setAttribute('onclick','showDLG('+_viewList[i+1].cardset_id+')')
            paperButton.innerHTML = _self.template.learn_more;
            divItem.appendChild(paperButton);
            paperCard.appendChild(divItem);
            rowDiv.appendChild(paperCard)
          }else
          { 
            paperCard = document.createElement('paper-card')
            paperCard.setAttribute('style','box-shadow:none')
            divItem = document.createElement('div')
            divItem.setAttribute('class','card-item');
            paperButton = document.createElement('paper-button')
            divItem.appendChild(paperButton);
            paperCard.appendChild(divItem);
            rowDiv.appendChild(paperCard)
          }

          objContent.appendChild(rowDiv)
        }

        _self.content.appendChild(objContent);
        //return objContent.innerHTML;
    }	
	//Check user login or not ??
	// this.checkLogin = function(successCallback, errorCallback){

	// }	

}
